package de.intevation.flys.artifacts.model;

import java.util.List;
import java.util.Iterator;

import de.intevation.flys.backend.SessionHolder;
import de.intevation.flys.model.Annotation;
import de.intevation.flys.model.Range;
import de.intevation.flys.model.River;

import org.hibernate.Session;
import org.hibernate.Query;

/**
 * @author <a href="mailto:ingo.weinzierl@intevation.de">Ingo Weinzierl</a>
 */
public class AnnotationsFactory {

    public static List<Annotation> getAnnotations(River river) {
        return getAnnotations(river.getName());
    }


    public static List<Annotation> getAnnotations(String river) {
        Session session = SessionHolder.HOLDER.get();

        Query rangesQuery = session.createQuery(
            "from Range where river.name=:name");
        rangesQuery.setParameter("name", river);
        List<Range> ranges = rangesQuery.list();

        Query query = session.createQuery(
            "from Annotation where range in (:ranges) order by range.a");
        query.setParameterList("ranges", ranges);
        return query.list();
    }


    public static Iterator<Annotation> getAnnotationsIterator(String river) {
        Session session = SessionHolder.HOLDER.get();

        Query rangesQuery = session.createQuery(
            "from Range where river.name=:name");
        rangesQuery.setParameter("name", river);
        List<Range> ranges = rangesQuery.list();

        Query query = session.createQuery(
            "from Annotation where range in (:ranges) order by range.a");
        query.setParameterList("ranges", ranges);
        return (Iterator<Annotation>)query.iterate();
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
